/**
 * ANTLR3 grammar for A2L (ASAM MCD - 2MC) version 1.6.<br>
 * The following files are generated by antlr: {@link: A2Lv16Lexer}, {@link: A2Lv16Parser}
 * Author: Philip Stoehrer
 */
grammar A2Lv16;

options {
    output=AST; // AST = Abstract Syntax Tree
    k=1;        // lookahead
}
tokens {
        /* Other keywords of A2L */
        BEGIN='/begin';
        END='/end';
        INCLUDE = '/include'; // TODO parsing includes.
        Container;
        Document;
}

@header {
/**
 * Copyright (C) 2011 Telemotive AG.
 * All rights reserved.
 */
package de.telemotive.bpng.client.ccpxcp.a2l.v16;
}

@lexer::header{
/**
 * Copyright (C) 2011 Telemotive AG.
 * All rights reserved.
 */
package de.telemotive.bpng.client.ccpxcp.a2l.v16;
}

@members {
//    @Override
//    protected Object recoverFromMismatchedToken(IntStream input,
//                                            int ttype,
//                                            BitSet follow)
//    throws RecognitionException
//{
//    throw new MismatchedTokenException(ttype, input);
//}

    public static String createTreeString(Tree tree) {
        return createTreeString(tree, 0).toString();
    }

    private static StringBuilder createTreeString(Tree t, int indent) {
        StringBuilder result = new StringBuilder();
        if (t != null) {
            StringBuffer sb = new StringBuffer(indent);
            for (int i = 0; i < indent; i++) {
                sb = sb.append("   ");
            }
            result.append(sb.toString());
            result.append(tokenNames[t.getType()]);
            result.append(": ");
            result.append(t.getText());
            result.append("\n");

            for (int i = 0; i < t.getChildCount(); i++) {
                result.append(createTreeString((CommonTree) t.getChild(i), indent + 1));
            }
        }
        return result;
    }
}

start: content -> ^(Document content);

content: (primitive | container)*;
primitive: (STRING | IDENT | NUMBER | HEX_NUMBER | UNESCAPED_STRING | INCLUDE);
container: BEGIN! ident^ content END! ident!;
ident: IDENT;

MULTILINE_COMMENT:   '/*' (options {greedy=false;} : .)* '*/' {skip();};
SINGLELINE_COMMENT: '//' ( (~('\r'|'\n'))* ) NEWLINE {skip();};
STRING: '"' (STRING_ESCAPE | ~('"'|'\\'))* '"';    // see ASAM_MCD-2MC_DataSpecification_V1.6.pdf, chapter 3.2: "Predefined Data Types"
UNESCAPED_STRING: '"' ~('"')* '"'; // Not allowed in A2L, but was added because some A2L files use a single backslash as normal character in strings.
WS: WS_CHARACTER+ {skip();};

IDENT: (LETTER|'_') (LETTER|DIGIT|'_'|'.'|'['|']')*;
NUMBER: ('-')? DIGIT+  ('.' DIGIT*)? EXPONENT? ;
HEX_NUMBER: '0' ('x'|'X') HEX_DIGIT+;
A2ML_STUFF: ('.'|';'|'{'|'}'|'='|'*'|'('|')'|','|'['|']'|'+') {skip();};

fragment VAR_NAME: (LETTER|'_') ALPHA_NUMERIC*;
fragment ALPHA_NUMERIC: (LETTER|DIGIT|'_');
fragment NEWLINE: '\r'? '\n'; // Supporting Windows and Unix linebreaks. (no Macintosh).
fragment WS_CHARACTER: ' '|'\t'|'\r'|'\n';
fragment DIGIT: '0'..'9';
fragment UPPER_CASE_LETTER: 'a'..'z';
fragment LOWER_CASE_LETTER: 'A'..'Z';
fragment LETTER: UPPER_CASE_LETTER|LOWER_CASE_LETTER;
fragment EXPONENT: ('e'|'E') ('-'|'+')? DIGIT+;
fragment HEX_DIGIT: '0'..'9' | 'A'..'F' | 'a'..'f';
fragment STRING_ESCAPE: '\\\u00B4' | '\\"' | '\\\\' | '\\n' | '\\r' | '\\t' | '""';