/**
 * ANTLR3 grammar for A2L (ASAM MCD - 2MC) version 1.6.<br>
 * The following files are generated by antlr: {@link: A2Lv16Lexer}, {@link: A2Lv16Parser}
 * Author: Philip Stoehrer
 */
grammar A2Lv16;

options {
    output=AST; // AST = Abstract Syntax Tree
    k=2;        // lookahead
}
tokens {
        /* Other keywords of A2L */
        BEGIN='/begin';
        END='/end';
        INCLUDE = '/include'; // TODO parsing includes.
        Container;
        Document;
}

@header {
/**
 * Copyright (C) 2011 Telemotive AG.
 * All rights reserved.
 */
package de.telemotive.bpng.client.ccpxcp.a2l.v16;
}

@lexer::header{
/**
 * Copyright (C) 2011 Telemotive AG.
 * All rights reserved.
 */
package de.telemotive.bpng.client.ccpxcp.a2l.v16;
}

@members {
    public static String createTreeString(Tree tree) {
        return createTreeString(tree, 0).toString();
    }

    private static StringBuffer createTreeString(Tree t, int indent) {
        StringBuffer result = new StringBuffer();
        if (t != null) {
            StringBuffer sb = new StringBuffer(indent);
            for (int i = 0; i < indent; i++) {
                sb = sb.append("   ");
            }
            result.append(sb.toString());
            result.append(tokenNames[t.getType()]);
            result.append(": ");
            result.append(t.getText());
            result.append("\n");

            for (int i = 0; i < t.getChildCount(); i++) {
                result.append(createTreeString((CommonTree) t.getChild(i), indent + 1));
            }
        }
        return result;
    }
}

start: content -> ^(Document content);

content: (primitive | container)*;

primitive: (STRING | IDENT | NUMBER | HEX_NUMBER);
container: BEGIN id1=IDENT content END id2=IDENT {$id1.text.equals($id2.text)}? -> ^(Container $id1 content); // TODO good error reporting

MULTILINE_COMMENT:   '/*' (options {greedy=false;} : .)* '*/' {$channel=HIDDEN;};
SINGLELINE_COMMENT: '//' ( ~('\r'|'\n')* ) NEWLINE {$channel=HIDDEN;};
WS: WS_CHARACTER+ {$channel=HIDDEN;};
IDENT: VAR_NAME ('['(DIGIT+ | VAR_NAME) ']')*;
NUMBER: ('-')? DIGIT+  ('.' DIGIT* EXPONENT?)? ;
HEX_NUMBER
	:	 '0' ('x'|'X') HEX_DIGIT+;
fragment VAR_NAME: (LETTER|'_')(LETTER|DIGIT|'_')*;
STRING: '"' (~'"'|'""')* '"';    // see ASAM_MCD-2MC_DataSpecification_V1.6.pdf, chapter 3.2: "Predefined Data Types"
//A2ML_BLOCK: BEGIN WS? A2ML (options {greedy=false;} : .)* END WS? A2ML;

// Supporting Windows and Unix linebreaks. (Windows: \r\n, Unix: \n).
fragment NEWLINE: '\r'? '\n';
fragment WS_CHARACTER: ' '|'\t'|'\r'|'\n';
fragment DIGIT: '0'..'9';
fragment UPPER_CASE_LETTER: 'a'..'z';
fragment LOWER_CASE_LETTER: 'A'..'Z';
fragment LETTER: UPPER_CASE_LETTER|LOWER_CASE_LETTER;
fragment EXPONENT: ('e'|'E') '-'? DIGIT+;
fragment HEX_DIGIT
	:	'0'..'9' | 'A'..'F' | 'a'..'f';