/**
 * ANTLR3 grammar for A2L (ASAM MCD - 2MC) version 1.6.<br>
 * The following files are generated by antlr: {@link: A2Lv16Lexer}, {@link: A2Lv16Parser}
 * Author: Philip Stoehrer
 */
grammar A2Lv16;

options {
    output=AST; // AST = Abstract Syntax Tree
    k=2;        // lookahead
}
tokens {
        /* A2L document root tag */
	DOCUMENT;

        /* Keywords defined in A2L specification: */
        A2ML = 'A2ML';
        A2ML_VERSION = 'A2ML_VERSION';
        ADDR_EPK = 'ADDR_EPK';
        ALIGNMENT_BYTE = 'ALIGNMENT_BYTE';
        ALIGNMENT_FLOAT32_IEEE = 'ALIGNMENT_FLOAT32_IEEE';
        ALIGNMENT_FLOAT64_IEEE = 'ALIGNMENT_FLOAT64_IEEE';
        ALIGNMENT_INT64 = 'ALIGNMENT_INT64';
        ALIGNMENT_LONG = 'ALIGNMENT_LONG';
        ALIGNMENT_WORD = 'ALIGNMENT_WORD';
        ANNOTATION = 'ANNOTATION';
        ANNOTATION_LABEL = 'ANNOTATION_LABEL';
        ANNOTATION_ORIGIN = 'ANNOTATION_ORIGIN';
        ANNOTATION_TEXT = 'ANNOTATION_TEXT';
        ARRAY_SIZE = 'ARRAY_SIZE';
        ASAP2_VERSION = 'ASAP2_VERSION';
        AXIS_DESCR = 'AXIS_DESCR';
        AXIS_PTS = 'AXIS_PTS';
        AXIS_PTS_REF = 'AXIS_PTS_REF';
        AXIS_PTS_X = 'AXIS_PTS_X';
        AXIS_PTS_Y = 'AXIS_PTS_Y';
        AXIS_PTS_Z = 'AXIS_PTS_Z';
        AXIS_PTS_4 = 'AXIS_PTS_4';
        AXIS_PTS_5 = 'AXIS_PTS_5';
        AXIS_RESCALE_X = 'AXIS_RESCALE_X';
        AXIS_RESCALE_Y = 'AXIS_RESCALE_Y';
        AXIS_RESCALE_Z = 'AXIS_RESCALE_Z';
        AXIS_RESCALE_4 = 'AXIS_RESCALE_4';
        AXIS_RESCALE_5 = 'AXIS_RESCALE_5';
        BIT_MASK = 'BIT_MASK';
        BIT_OPERATION = 'BIT_OPERATION';
        BYTE_ORDER = 'BYTE_ORDER';
        CALIBRATION_ACCESS = 'CALIBRATION_ACCESS';
        CALIBRATION_HANDLE = 'CALIBRATION_HANDLE';
        CALIBRATION_HANDLE_TEXT = 'CALIBRATION_HANDLE_TEXT';
        CALIBRATION_METHOD = 'CALIBRATION_METHOD';
        CHARACTERISTIC = 'CHARACTERISTIC';
        COEFFS = 'COEFFS';
        COEFFS_LINEAR = 'COEFFS_LINEAR';
        COMPARISON_QUANTITY = 'COMPARISON_QUANTITY';
        COMPU_METHOD = 'COMPU_METHOD';
        COMPU_TAB = 'COMPU_TAB';
        COMPU_TAB_REF = 'COMPU_TAB_REF';
        COMPU_VTAB = 'COMPU_VTAB';
        COMPU_VTAB_RANGE = 'COMPU_VTAB_RANGE';
        CPU_TYPE = 'CPU_TYPE';
        CURVE_AXIS_REF = 'CURVE_AXIS_REF';
        CUSTOMER = 'CUSTOMER';
        CUSTOMER_NO = 'CUSTOMER_NO';
        DATA_SIZE = 'DATA_SIZE';
        DEF_CHARACTERISTIC = 'DEF_CHARACTERISTIC';
        DEFAULT_VALUE = 'DEFAULT_VALUE';
        DEFAULT_VALUE_NUMERIC = 'DEFAULT_VALUE_NUMERIC';
        DEPENDENT_CHARACTERISTIC = 'DEPENDENT_CHARACTERISTIC';
        DEPOSIT = 'DEPOSIT';
        DISCRETE = 'DISCRETE';
        DISPLAY_IDENTIFIER = 'DISPLAY_IDENTIFIER';
        DIST_OP_X = 'DIST_OP_X';
        DIST_OP_Y = 'DIST_OP_Y';
        DIST_OP_Z = 'DIST_OP_Z';
        DIST_OP_4 = 'DIST_OP_4';
        DIST_OP_5 = 'DIST_OP_5';
        ECU = 'ECU';
        ECU_ADDRESS = 'ECU_ADDRESS';
        ECU_ADDRESS_EXTENSION = 'ECU_ADDRESS_EXTENSION';
        ECU_CALIBRATION_OFFSET = 'ECU_CALIBRATION_OFFSET';
        EPK = 'EPK';
        ERROR_MASK = 'ERROR_MASK';
        EXTENDED_LIMITS = 'EXTENDED_LIMITS';
        FIX_AXIS_PAR = 'FIX_AXIS_PAR';
        FIX_AXIS_PAR_DIST = 'FIX_AXIS_PAR_DIST';
        FIX_AXIS_PAR_LIST = 'FIX_AXIS_PAR_LIST';
        FIX_NO_AXIS_PTS_X = 'FIX_NO_AXIS_PTS_X';
        FIX_NO_AXIS_PTS_Y = 'FIX_NO_AXIS_PTS_Y';
        FIX_NO_AXIS_PTS_Z = 'FIX_NO_AXIS_PTS_Z';
        FIX_NO_AXIS_PTS_4 = 'FIX_NO_AXIS_PTS_4';
        FIX_NO_AXIS_PTS_5 = 'FIX_NO_AXIS_PTS_5';
        FNC_VALUES = 'FNC_VALUES';
        FORMAT = 'FORMAT';
        FORMULA = 'FORMULA';
        FORMULA_INV = 'FORMULA_INV';
        FRAME = 'FRAME';
        FRAME_MEASUREMENT = 'FRAME_MEASUREMENT';
        FUNCTION = 'FUNCTION';
        FUNCTION_LIST = 'FUNCTION_LIST';
        FUNCTION_VERSION = 'FUNCTION_VERSION';
        GROUP = 'GROUP';
        GUARD_RAILS = 'GUARD_RAILS';
        HEADER = 'HEADER';
        IDENTIFICATION = 'IDENTIFICATION';
        IF_DATA = 'IF_DATA';
        IN_MEASUREMENT = 'IN_MEASUREMENT';
        LAYOUT = 'LAYOUT';
        LEFT_SHIFT = 'LEFT_SHIFT';
        LOC_MEASUREMENT = 'LOC_MEASUREMENT';
        MAP_LIST = 'MAP_LIST';
        MATRIX_DIM = 'MATRIX_DIM';
        MAX_GRAD = 'MAX_GRAD';
        MAX_REFRESH = 'MAX_REFRESH';
        MEASUREMENT = 'MEASUREMENT';
        MEMORY_LAYOUT = 'MEMORY_LAYOUT';
        MEMORY_SEGMENT = 'MEMORY_SEGMENT';
        MOD_COMMON = 'MOD_COMMON';
        MOD_PAR = 'MOD_PAR';
        MODULE = 'MODULE';
        MONOTONY = 'MONOTONY';
        NO_AXIS_PTS_X = 'NO_AXIS_PTS_X';
        NO_AXIS_PTS_Y = 'NO_AXIS_PTS_Y';
        NO_AXIS_PTS_Z = 'NO_AXIS_PTS_Z';
        NO_AXIS_PTS_4 = 'NO_AXIS_PTS_4';
        NO_AXIS_PTS_5 = 'NO_AXIS_PTS_5';
        NO_OF_INTERFACES = 'NO_OF_INTERFACES';
        NO_RESCALE_X = 'NO_RESCALE_X';
        NO_RESCALE_Y = 'NO_RESCALE_Y';
        NO_RESCALE_Z = 'NO_RESCALE_Z';
        NO_RESCALE_4 = 'NO_RESCALE_4';
        NO_RESCALE_5 = 'NO_RESCALE_5';
        NUMBER = 'NUMBER';
        OFFSET_X = 'OFFSET_X';
        OFFSET_Y = 'OFFSET_Y';
        OFFSET_Z = 'OFFSET_Z';
        OFFSET_4 = 'OFFSET_4';
        OFFSET_5 = 'OFFSET_5';
        OUT_MEASUREMENT = 'OUT_MEASUREMENT';
        PHONE_NO = 'PHONE_NO';
        PHYS_UNIT = 'PHYS_UNIT';
        PROJECT = 'PROJECT';
        PROJECT_NO = 'PROJECT_NO';
        READ_ONLY = 'READ_ONLY';
        READ_WRITE = 'READ_WRITE';
        RECORD_LAYOUT = 'RECORD_LAYOUT';
        REF_CHARACTERISTIC = 'REF_CHARACTERISTIC';
        REF_GROUP = 'REF_GROUP';
        REF_MEASUREMENT = 'REF_MEASUREMENT';
        REF_MEMORY_SEGMENT = 'REF_MEMORY_SEGMENT';
        REF_UNIT = 'REF_UNIT';
        RESERVED = 'RESERVED';
        RIGHT_SHIFT = 'RIGHT_SHIFT';
        RIP_ADDR_W = 'RIP_ADDR_W';
        RIP_ADDR_X = 'RIP_ADDR_X';
        RIP_ADDR_Y = 'RIP_ADDR_Y';
        RIP_ADDR_Z = 'RIP_ADDR_Z';
        RIP_ADDR_4 = 'RIP_ADDR_4';
        RIP_ADDR_5 = 'RIP_ADDR_5';
        ROOT = 'ROOT';
        SHIFT_OP_X = 'SHIFT_OP_X';
        SHIFT_OP_Y = 'SHIFT_OP_Y';
        SHIFT_OP_Z = 'SHIFT_OP_Z';
        SHIFT_OP_4 = 'SHIFT_OP_4';
        SHIFT_OP_5 = 'SHIFT_OP_5';
        SIGN_EXTEND = 'SIGN_EXTEND';
        SI_EXPONENTS = 'SI_EXPONENTS';
        SRC_ADDR_X = 'SRC_ADDR_X';
        SRC_ADDR_Y = 'SRC_ADDR_Y';
        SRC_ADDR_Z = 'SRC_ADDR_Z';
        SRC_ADDR_4 = 'SRC_ADDR_4';
        SRC_ADDR_5 = 'SRC_ADDR_5';
        STATIC_RECORD_LAYOUT = 'STATIC_RECORD_LAYOUT';
        STATUS_STRING_REF = 'STATUS_STRING_REF';
        STEP_SIZE = 'STEP_SIZE';
        SUB_FUNCTION = 'SUB_FUNCTION';
        SUB_GROUP = 'SUB_GROUP';
        SUPPLIER = 'SUPPLIER';
        SYMBOL_LINK = 'SYMBOL_LINK';
        SYSTEM_CONSTANT = 'SYSTEM_CONSTANT';
        S_REC_LAYOUT = 'S_REC_LAYOUT';
        UNIT = 'UNIT';
        UNIT_CONVERSION = 'UNIT_CONVERSION';
        USER = 'USER';
        USER_RIGHTS = 'USER_RIGHTS';
        VAR_ADDRESS = 'VAR_ADDRESS';
        VAR_CHARACTERISTIC = 'VAR_CHARACTERISTIC';
        VAR_CRITERION = 'VAR_CRITERION';
        VAR_FORBIDDEN_COMB = 'VAR_FORBIDDEN_COMB';
        VAR_MEASUREMENT = 'VAR_MEASUREMENT';
        VAR_NAMING = 'VAR_NAMING';
        VAR_SELECTION_CHARACTERISTIC = 'VAR_SELECTION_CHARACTERISTIC';
        VAR_SEPARATOR = 'VAR_SEPARATOR';
        VARIANT_CODING = 'VARIANT_CODING';
        VERSION = 'VERSION';
        VIRTUAL = 'VIRTUAL';
        VIRTUAL_CHARACTERISTIC = 'VIRTUAL_CHARACTERISTIC';

        /* Enum values for BYTE_ORDER */
        MSB_FIRST = 'MSB_FIRST';
        LITTLE_ENDIAN = 'LITTLE_ENDIAN';
        MSB_LAST = 'MSB_LAST';
        BIG_ENDIAN = 'BIG_ENDIAN';

        /* Enum values for CALIBRATION_ACCESS */
        CALIBRATION = 'CALIBRATION';
        NO_CALIBRATION = 'NO_CALIBRATION';
        NOT_IN_MCD_SYSTEM = 'NOT_IN_MCD_SYSTEM';
        OFFLINE_CALIBRATION = 'OFFLINE_CALIBRATION';

        /* Enum values for DEPOSIT */
        ABSOLUTE = 'ABSOLUTE';
        DIFFERENCE = 'DIFFERENCE';

        /* Enum values for MONOTONY */
        MON_DECREASE = 'MON_DECREASE';
        MON_INCREASE = 'MON_INCREASE';
        STRICT_DECREASE = 'STRICT_DECREASE';
        STRICT_INCREASE = 'STRICT_INCREASE';
        MONOTONOUS = 'MONOTONOUS';
        STRICT_MON = 'STRICT_MON';
        NOT_MON = 'NOT_MON';

        /* Enum values for type */
        ASCII = 'ASCII';
        CURVE = 'CURVE';
        MAP = 'MAP';
        CUBOID = 'CUBOID';
        CUBE_4 = 'CUBE_4';
        CUBE_5 = 'CUBE_5';
        VAL_BLK = 'VAL_BLK';
        VALUE = 'VALUE';

        /* Other keywords of A2L */
        BEGIN='/begin';
        END='/end';
        INCLUDE = '/include'; // TODO parsing includes.


        /* Keywords of A2ML */
        BLOCK = 'block';
        CHAR_TYPE = 'char';
        CURLY_BRACKET_CLOSE = '}';
        CURLY_BRACKET_OPEN = '{';
        DOUBLE_TYPE = 'double';
        ENUM_TYPE = 'enum';
        FLOAT_TYPE = 'float';
        INT_TYPE = 'int' ;
        LONG_TYPE = 'long';
        STRUCT_TYPE = 'struct';
        TAGGEDSTRUCT_TYPE = 'taggedstruct';
        TAGGEDUNION_TYPE = 'taggedunion';
        UCHAR_TYPE = 'uchar';
        UINT_TYPE = 'uint';
        ULONG_TYPE = 'ulong';

        /* Property names defined in A2L specification: */
        Address;                // used by AXIS_PTS, CHARACTERISTIC
        ArraySpecifier;         // used by ident
        Attribute;              // used by MEMORY_SEGMENT
        Comment;                // used by HEADER
        Constant;               // used by A2ML
        ControlUnit;            // used by ECU
        Conversion;             // used by AXIS_PTS, CHARACTERISTIC
        Customer;               // used by CUSTOMER
        CPU;                    // used by CPU_TYPE
        Deposit;                // used by AXIS_PTS, CHARACTERISTIC
        Enumerator;             // used by A2ML
        Ident;                  // used by ident
        Identifier;             // used by A2ML "enum"
        IfDataBlock;            // used by IF_DATA
        InputQuantity;          // used by AXIS_PTS
        Keyword;                // used by A2ML "enum"
        LongIdentifier;         // used by PROJECT, MODULE, AXIS_PTS, CHARACTERISTIC
        LowerLimit;             // used by AXIS_PTS, CHARACTERISTIC
        Manufacturer;           // used by SUPPLIER
        MaxAxisPoints;          // used by AXIS_PTS
        MaxDiff;                // used by AXIS_PTS, CHARACTERISTIC
        MemoryType;             // used by MEMORY_SEGMENT
        Method;                 // used by CALIBRATION_METHOD
        Name;                   // used by PROJECT, MODULE, AXIS_PTS, CHARACTERISTIC
        Offset;                 // used by SYMBOL_LINK, ECU_CALIBRATION_OFFSET
        Param;			// used by IF_DATA
        PartialIdent;           // used by ident
        PredefinedType;         // used by A2ML
        PrgType;                // used by MEMORY_LAYOUT
        SymbolName;             // used by SYMBOL_LINK
        Size;                   // used by MEMORY_LAYOUT
        Tag;                    // used by A2ML "block".
        Telnum;                 // used by PHONE_NO
        Type;                   // used by CHARACTERISTIC
        UpgradeNo;              // used by A2ML_VERSION, ASAP2_VERSION
        UpperLimit;             // used by AXIS_PTS, CHARACTERISTIC
        UserName;               // used by USER
        Value;                  // used by SYSTEM_CONSTANT
        Version;                // used by CALIBRATION_METHOD
        VersionIdentifier;      // used by VERSION
        VersionNo;              // used by A2ML_VERSION, ASAP2_VERSION
}

@header {
/**
 * Copyright (C) 2011 Telemotive AG.
 * All rights reserved.
 */
package de.telemotive.bpng.client.ccpxcp.a2l.v16;
}

@lexer::header{
/**
 * Copyright (C) 2011 Telemotive AG.
 * All rights reserved.
 */
package de.telemotive.bpng.client.ccpxcp.a2l.v16;
}

@members {
    public static String createTreeString(Tree tree) {
        return createTreeString(tree, 0).toString();
    }

    private static StringBuffer createTreeString(Tree t, int indent) {
        StringBuffer result = new StringBuffer();
        if (t != null) {
            StringBuffer sb = new StringBuffer(indent);
            for (int i = 0; i < indent; i++) {
                sb = sb.append("   ");
            }
            result.append(sb.toString());
            result.append(tokenNames[t.getType()]);
            result.append(": ");
            result.append(t.getText());
            result.append("\n");

            for (int i = 0; i < t.getChildCount(); i++) {
                result.append(createTreeString((CommonTree) t.getChild(i), indent + 1));
            }
        }
        return result;
    }
}

start: document -> ^(DOCUMENT document);

document: asap2Version? a2mlVersion? cProject;

// Version
asap2Version: ASAP2_VERSION^ versionNo upgradeNo;
a2mlVersion: A2ML_VERSION^ versionNo upgradeNo;
versionNo: uint -> ^(VersionNo uint);
upgradeNo: uint -> ^(UpgradeNo uint);

// Definition of PROJECT container. Parent: DOCUMENT.
cProject: BEGIN! project END! PROJECT!;
project: projectDef^ cHeader cModule*;
projectDef: PROJECT^ name longIdentifier;

// Definition of HEADER container. Parent: PROJECT.
cHeader: BEGIN! head END! HEADER!;
head: headerDef^ headerVersion? headerProjectNo?;
headerDef: HEADER^ comment;
comment: STRING -> ^(Comment STRING);
headerVersion: VERSION^ STRING;
headerProjectNo: PROJECT_NO^ ident;

// Definition of MODULE container. Parent: PROJECT.
cModule: BEGIN! module END! MODULE!;
module: moduleDef^ moduleContent;
moduleDef: MODULE^ name longIdentifier;
//moduleContent: cA2ml? cAxisPts* cCharacteristic* cCompuMethod* cCompuTab* cCompuVtab* cCompuVtabRange*
//            cFrame? cFunction* cGroup* cIfData* cMeasurement* cModCommon? cModPar? cRecordLayout* cUnit*
//            cUserRights* cVariantCoding?;
moduleContent: (cA2ml | cAxisPts | cCharacteristic | cCompuMethod | cCompuTab | cCompuVtab | cCompuVtabRange |
            cFrame | cFunction | cGroup| cIfData | cMeasurement | cModCommon | cModPar | cRecordLayout | cUnit |
            cUserRights | cVariantCoding)* ;  /* Not the exact rule, it makes more possible than allowed.
                                                 But otherwise the grammar would explode. */

// Definition of A2ML container. Parent: MODULE.
cA2ml: BEGIN! a2ml END! A2ML!;
//cA2ml: A2ML_BLOCK -> ^(A2ML {parseA2ml($A2ML_BLOCK.text)});
a2ml: A2ML^ declaration*;
declaration: type_definition ';'! | block_definition ';'!;
type_definition: type_name;
type_name: predefined_type_name
            | struct_type_name
            | taggedstruct_type_name
            | taggedunion_type_name
            | enum_type_name;
predefined_type_name: CHAR_TYPE -> ^(PredefinedType CHAR_TYPE)
                        | INT_TYPE -> ^(PredefinedType INT_TYPE)
                        | LONG_TYPE -> ^(PredefinedType LONG_TYPE)
                        | UCHAR_TYPE -> ^(PredefinedType UCHAR_TYPE)
                        | UINT_TYPE -> ^(PredefinedType UINT_TYPE)
                        | ULONG_TYPE -> ^(PredefinedType ULONG_TYPE)
                        | FLOAT_TYPE -> ^(PredefinedType FLOAT_TYPE)
                        | DOUBLE_TYPE -> ^(PredefinedType DOUBLE_TYPE);
block_definition: BLOCK^ tag type_name;
enum_type_name: (ENUM_TYPE^ identifier? CURLY_BRACKET_OPEN!)    // Optimization: using predicate to reduce lookahead to k=2.
    => ENUM_TYPE^ identifier? CURLY_BRACKET_OPEN! enumerator_list CURLY_BRACKET_CLOSE!
                    | ENUM_TYPE^ identifier;
enumerator_list: enumerator (','! enumerator)*;
enumerator: keyword ('=' constant)? -> ^(Enumerator keyword constant?);
struct_type_name: (STRUCT_TYPE^ identifier? CURLY_BRACKET_OPEN!) // Optimization: using predicate to reduce lookahead to k=2.
    => STRUCT_TYPE^ identifier? CURLY_BRACKET_OPEN! struct_member_list CURLY_BRACKET_CLOSE!
                    | STRUCT_TYPE^ identifier;
struct_member_list: struct_member*;
struct_member: member ';'!;
member: type_name^ array_specifier*;
array_specifier: '['! constant ']'!;
taggedstruct_type_name:
    (TAGGEDSTRUCT_TYPE^ identifier? CURLY_BRACKET_OPEN!) // Optimization: using predicate to reduce lookahead to k=2.
    => TAGGEDSTRUCT_TYPE^ identifier? CURLY_BRACKET_OPEN! taggedstruct_member_list CURLY_BRACKET_CLOSE!
                            | TAGGEDSTRUCT_TYPE^ identifier;
taggedstruct_member_list: taggedstruct_member*;
taggedstruct_member: taggedstruct_definition ';'!?      /*
                                                           [PhS]: I'm making the closing semicolon optional,
                                                           because Daimler does not always use semicolons here,
                                                           though A2L specification defines it as mandatory.
                                                           Maybe this is a fault in A2L spec, because it leads to
                                                           curious constructs like mandatory double semicolons (';;').
                                                        */
                        | '('! taggedstruct_definition ')'! '*'! ';'!
                        | block_definition ';'!
                        | '('! block_definition ')'! '*'! ';'!;
taggedstruct_definition: tag ((member?)| '('! member? ')'! '*'! ';'!);
taggedunion_type_name: (TAGGEDUNION_TYPE^ identifier? CURLY_BRACKET_OPEN!) // Optimization: using predicate to reduce lookahead to k=2.
    => TAGGEDUNION_TYPE^ identifier? CURLY_BRACKET_OPEN! taggedunion_member_list CURLY_BRACKET_CLOSE!
                            | TAGGEDUNION_TYPE^ identifier;
taggedunion_member_list: tagged_union_member*;
tagged_union_member:  (tag member? | block_definition) ';'!;

/* Defintion of ANNOTATION container. Parent: AXIS_PTS (and others).*/
cAnnotation
	:	BEGIN! annotation END! ANNOTATION!;
annotation
	:	ANNOTATION^ annotationLabel? annotationOrigin? cAnnotationText?;
annotationLabel
	:	ANNOTATION_LABEL^ STRING;
annotationOrigin
	:	ANNOTATION_ORIGIN^ STRING;
cAnnotationText
	:	BEGIN! annotationText END! ANNOTATION_TEXT!;
annotationText
	:	ANNOTATION_TEXT^ STRING*;

/* Definition of AXIS_PTS container. Parent: MODULE */
cAxisPts: BEGIN! axisPts  END! AXIS_PTS!;
axisPts: AXIS_PTS^ axisParams;
axisParams: name longIdentifier address inputQuantity deposit maxDiff conversion maxAxisPoints lowerLimit upperLimit
		cAnnotation* eByteOrder? eCalibrationAccess? eDeposit? displayIdentifier? ecuAddressExtension? extendedLimits?
		format? cFunctionList? GUARD_RAILS? cIfData* eMonotony? physUnit? READ_ONLY? refMemorySegment? stepSize? symbolLink?;

/* Definition of container CHARACTERISTIC. Parent: MODULE */
// TODO Go on here to complete the grammar!
//cCharacteristic: BEGIN! characteristic END! CHARACTERISTIC!;
//characteristic: CHARACTERISTIC^ name longIdentifier type address deposit maxDiff conversion lowerLimit upperLimit
//                                cAnnotation* cAxisDescr* bitMask* byteOrder? eCalibrationAccess? comparisonQuantity?
//                                dependendCharacteristic? DISCRETE? displayIdentifier? ecuAddressExtension? extendedLimits?
//                                format? cFFunctionList? GUARD_RAILS? cIfData* cMapList? matrixDim? maxRefresh? number?
//                                number? physUnit? READ_ONLY? refMemorySegment? stepSize? symbolicLink? cVirtualCharacteristic?;

/*
    Droppingparts of file, which are not needed yet.
    TODO replace with real rules to parse it.
*/

cCharacteristic: BEGIN! characteristic END! CHARACTERISTIC!;
characteristic: CHARACTERISTIC^ (options {greedy=false;} : .)*;

cCompuMethod: BEGIN! compuMethod END! COMPU_METHOD!;
compuMethod: COMPU_METHOD^ (options {greedy=false;} : .)*;

cCompuTab: BEGIN! compuTab END! COMPU_TAB;
compuTab: COMPU_TAB^ (options {greedy=false;} : .)*;

cCompuVtab: BEGIN! compuVtab END! COMPU_VTAB!;
compuVtab: COMPU_VTAB^ (options {greedy=false;} : .)*;

cCompuVtabRange: BEGIN! compuVtabRange END! COMPU_VTAB_RANGE!;
compuVtabRange: COMPU_VTAB_RANGE^ (options {greedy=false;} : .)*;

cFrame: BEGIN! frame END! FRAME!;
frame: FRAME^ (options {greedy=false;} : .)*;

cFunction: BEGIN! function END! FUNCTION!;
function: FUNCTION^ (options {greedy=false;} : .)*;

cGroup: BEGIN! group END! GROUP!;
group: GROUP^ (options {greedy=false;} : .)*;

cMeasurement: BEGIN! measurement END! MEASUREMENT;
measurement: MEASUREMENT^ (options {greedy=false;} : .)*;

cModCommon: BEGIN! modCommon END! MOD_COMMON!;
modCommon: MOD_COMMON^ (options {greedy=false;} : .)*;

cModPar: BEGIN! modPar END! MOD_PAR!;
modPar: MOD_PAR^  (options {greedy=false;} : .)*;
//modPar: MOD_PAR^ comment addrEpk* cCalibrationMethod* cpuType? customer? ecu?
//        ecuCalibrationOffset? epk? memoryLayout* memorySegment* noOfInterfaces?
//        phoneNo? supplier? systemConstant* user? version?;
addrEpk: ADDR_EPK^ address;
cpuType: CPU_TYPE^ cpu;
customer: CUSTOMER^ customerSimple;
customerSimple: STRING -> ^(Customer STRING);
ecu: ECU^ controlUnit;
controlUnit: STRING -> ^(ControlUnit STRING);
ecuCalibrationOffset: ECU_CALIBRATION_OFFSET^ offset;
offset: integer -> ^(Offset integer);
epk: EPK^ strIdentifier;
strIdentifier: STRING -> ^(Identifier STRING);


//cCalibrationMethod: BEGIN! calibrationMethod END! CALIBRATION_METHOD!
//calibrationMethod: CALIBRATION_METHOD^ method version cCalibrationHandle?;


cCalibrationHandle: BEGIN! calibrationHandle END! CALIBRATION_HANDLE!;
calibrationHandle: CALIBRATION_HANDLE^ uint*;

cRecordLayout: BEGIN! recordLayout END! RECORD_LAYOUT;
recordLayout: RECORD_LAYOUT^ (options {greedy=false;} : .)*;

cUnit: BEGIN! unit END! UNIT!;
unit: UNIT^ (options {greedy=false;} : .)*;

cUserRights: BEGIN! userRights END! USER_RIGHTS!;
userRights: USER_RIGHTS^ (options {greedy=false;} : .)*;

cVariantCoding: BEGIN! variantCoding END! VARIANT_CODING!;
variantCoding: VARIANT_CODING^ (options {greedy=false;} : .)*;

/* Container FUNCTION_LIST */
cFunctionList
	:	BEGIN! functionList END! FUNCTION_LIST;
functionList
	:	FUNCTION_LIST^ name*;

/* Definition of container IF_DATA. Parent: MODULE (and others). */
cIfData	:	BEGIN! ifData END! IF_DATA!;
ifData	:	IF_DATA^ name (param | cAny)*;
cAny	:	BEGIN id1=identifier  (param | cAny)* END id2=identifier {$id1.text.equals($id2.text)}? -> ^(IfDataBlock $id1 param*); // TODO good error reporting

// Enums
eByteOrder
	:	BYTE_ORDER^ (MSB_FIRST | LITTLE_ENDIAN | MSB_LAST | BIG_ENDIAN);	// Legacy values: 'LITTLE_ENDIAN', 'BIG_ENDIAN' for version < 1.2.
eCalibrationAccess
	:	CALIBRATION_ACCESS^ (CALIBRATION | NO_CALIBRATION | NOT_IN_MCD_SYSTEM | OFFLINE_CALIBRATION);
eDeposit:	DEPOSIT^ (ABSOLUTE | DIFFERENCE);
eMonotony: MONOTONY^ (MON_DECREASE | MON_INCREASE | STRICT_DECREASE | STRICT_INCREASE | MONOTONOUS | STRICT_MON | NOT_MON);

// Common used rules:
address : uint -> ^(Address uint);
comparisonQuantity: COMPARISON_QUANTITY ident;
constant: uint -> ^(Constant uint);
conversion
	:	 ident -> ^(Conversion ident);
cpu: STRING -> ^(CPU STRING);
displayIdentifier
	:	DISPLAY_IDENTIFIER^ ident;
ecuAddressExtension
	:	ECU_ADDRESS_EXTENSION^ (uint | NEG_INT);
extendedLimits
	:	EXTENDED_LIMITS^ lowerLimit upperLimit;
format	:	FORMAT^ STRING;
ident: (partIdent) ('.'! partIdent)*;
identifier : ident -> ^(Identifier ident);       // Unknown, which tokens are allowed for identifier. Assuming 'ident' type.
inputQuantity
	:	ident -> ^(InputQuantity ident)
	;
integer: (POS_INT | NEG_INT | HEX_NUMBER);
deposit	:	ident -> ^(Deposit ident)
	;
keyword: STRING -> ^(Keyword STRING);           // Unknown, which tokens are allowed for keyword. Assuming 'string' type.
maxAxisPoints
	:	uint -> ^(MaxAxisPoints uint);
lowerLimit
	:	FLOAT -> ^(LowerLimit FLOAT);
upperLimit
	:	FLOAT -> ^(UpperLimit FLOAT);
maxDiff	:	FLOAT -> ^(MaxDiff FLOAT);
method: STRING -> ^(Method STRING);
name: ident -> ^(Name ident);
longIdentifier: STRING -> ^(LongIdentifier STRING);
param	:	 POS_INT -> ^(Param POS_INT)
		| NEG_INT -> ^(Param NEG_INT)
		| FLOAT -> ^(Param FLOAT)
		| HEX_NUMBER -> ^(Param HEX_NUMBER)
		| STRING -> ^(Param STRING)
                | ident -> ^(Param ident);
partIdent: ((varName=VAR_NAME ('[' arSpec=(DIGIT+ | VAR_NAME) ']')*)  | varName=A2ML | varName=A2ML_VERSION | varName=ADDR_EPK | varName=ALIGNMENT_BYTE | varName=ALIGNMENT_FLOAT32_IEEE | varName=ALIGNMENT_FLOAT64_IEEE | varName=ALIGNMENT_INT64 | varName=ALIGNMENT_LONG | varName=ALIGNMENT_WORD | varName=ANNOTATION | varName=ANNOTATION_LABEL | varName=ANNOTATION_ORIGIN | varName=ANNOTATION_TEXT | varName=ARRAY_SIZE | varName=ASAP2_VERSION | varName=AXIS_DESCR | varName=AXIS_PTS | varName=AXIS_PTS_REF | varName=AXIS_PTS_X | varName=AXIS_PTS_Y | varName=AXIS_PTS_Z | varName=AXIS_PTS_4 | varName=AXIS_PTS_5 | varName=AXIS_RESCALE_X | varName=AXIS_RESCALE_Y | varName=AXIS_RESCALE_Z | varName=AXIS_RESCALE_4 | varName=AXIS_RESCALE_5 | varName=BIT_MASK | varName=BIT_OPERATION | varName=BYTE_ORDER | varName=CALIBRATION_ACCESS | varName=CALIBRATION_HANDLE | varName=CALIBRATION_HANDLE_TEXT | varName=CALIBRATION_METHOD | varName=CHARACTERISTIC | varName=COEFFS | varName=COEFFS_LINEAR | varName=COMPARISON_QUANTITY | varName=COMPU_METHOD | varName=COMPU_TAB | varName=COMPU_TAB_REF | varName=COMPU_VTAB | varName=COMPU_VTAB_RANGE | varName=CPU_TYPE | varName=CURVE_AXIS_REF | varName=CUSTOMER | varName=CUSTOMER_NO | varName=DATA_SIZE | varName=DEF_CHARACTERISTIC | varName=DEFAULT_VALUE | varName=DEFAULT_VALUE_NUMERIC | varName=DEPENDENT_CHARACTERISTIC | varName=DEPOSIT | varName=DISCRETE | varName=DISPLAY_IDENTIFIER | varName=DIST_OP_X | varName=DIST_OP_Y | varName=DIST_OP_Z | varName=DIST_OP_4 | varName=DIST_OP_5 | varName=ECU | varName=ECU_ADDRESS | varName=ECU_ADDRESS_EXTENSION | varName=ECU_CALIBRATION_OFFSET | varName=EPK | varName=ERROR_MASK | varName=EXTENDED_LIMITS | varName=FIX_AXIS_PAR | varName=FIX_AXIS_PAR_DIST | varName=FIX_AXIS_PAR_LIST | varName=FIX_NO_AXIS_PTS_X | varName=FIX_NO_AXIS_PTS_Y | varName=FIX_NO_AXIS_PTS_Z | varName=FIX_NO_AXIS_PTS_4 | varName=FIX_NO_AXIS_PTS_5 | varName=FNC_VALUES | varName=FORMAT | varName=FORMULA | varName=FORMULA_INV | varName=FRAME | varName=FRAME_MEASUREMENT | varName=FUNCTION | varName=FUNCTION_LIST | varName=FUNCTION_VERSION | varName=GROUP | varName=GUARD_RAILS | varName=HEADER | varName=IDENTIFICATION | varName=IF_DATA | varName=IN_MEASUREMENT | varName=LAYOUT | varName=LEFT_SHIFT | varName=LOC_MEASUREMENT | varName=MAP_LIST | varName=MATRIX_DIM | varName=MAX_GRAD | varName=MAX_REFRESH | varName=MEASUREMENT | varName=MEMORY_LAYOUT | varName=MEMORY_SEGMENT | varName=MOD_COMMON | varName=MOD_PAR | varName=MODULE | varName=MONOTONY | varName=NO_AXIS_PTS_X | varName=NO_AXIS_PTS_Y | varName=NO_AXIS_PTS_Z | varName=NO_AXIS_PTS_4 | varName=NO_AXIS_PTS_5 | varName=NO_OF_INTERFACES | varName=NO_RESCALE_X | varName=NO_RESCALE_Y | varName=NO_RESCALE_Z | varName=NO_RESCALE_4 | varName=NO_RESCALE_5 | varName=NUMBER | varName=OFFSET_X | varName=OFFSET_Y | varName=OFFSET_Z | varName=OFFSET_4 | varName=OFFSET_5 | varName=OUT_MEASUREMENT | varName=PHONE_NO | varName=PHYS_UNIT | varName=PROJECT | varName=PROJECT_NO | varName=READ_ONLY | varName=READ_WRITE | varName=RECORD_LAYOUT | varName=REF_CHARACTERISTIC | varName=REF_GROUP | varName=REF_MEASUREMENT | varName=REF_MEMORY_SEGMENT | varName=REF_UNIT | varName=RESERVED | varName=RIGHT_SHIFT | varName=RIP_ADDR_W | varName=RIP_ADDR_X | varName=RIP_ADDR_Y | varName=RIP_ADDR_Z | varName=RIP_ADDR_4 | varName=RIP_ADDR_5 | varName=ROOT | varName=SHIFT_OP_X | varName=SHIFT_OP_Y | varName=SHIFT_OP_Z | varName=SHIFT_OP_4 | varName=SHIFT_OP_5 | varName=SIGN_EXTEND | varName=SI_EXPONENTS | varName=SRC_ADDR_X | varName=SRC_ADDR_Y | varName=SRC_ADDR_Z | varName=SRC_ADDR_4 | varName=SRC_ADDR_5 | varName=STATIC_RECORD_LAYOUT | varName=STATUS_STRING_REF | varName=STEP_SIZE | varName=SUB_FUNCTION | varName=SUB_GROUP | varName=SUPPLIER | varName=SYMBOL_LINK | varName=SYSTEM_CONSTANT | varName=S_REC_LAYOUT | varName=UNIT | varName=UNIT_CONVERSION | varName=USER | varName=USER_RIGHTS | varName=VAR_ADDRESS | varName=VAR_CHARACTERISTIC | varName=VAR_CRITERION | varName=VAR_FORBIDDEN_COMB | varName=VAR_MEASUREMENT | varName=VAR_NAMING | varName=VAR_SELECTION_CHARACTERISTIC | varName=VAR_SEPARATOR | varName=VARIANT_CODING | varName=VERSION | varName=VIRTUAL | varName=VIRTUAL_CHARACTERISTIC | varName=MSB_FIRST| varName=LITTLE_ENDIAN| varName=MSB_LAST| varName=BIG_ENDIAN| varName=CALIBRATION| varName=NO_CALIBRATION| varName=NOT_IN_MCD_SYSTEM| varName=OFFLINE_CALIBRATION| varName=ABSOLUTE| varName=DIFFERENCE| varName=MON_DECREASE| varName=MON_INCREASE| varName=STRICT_DECREASE| varName=STRICT_INCREASE| varName=MONOTONOUS| varName=STRICT_MON| varName=NOT_MON| varName=ASCII| varName=CURVE| varName=MAP| varName=CUBOID| varName=CUBE_4| varName=CUBE_5| varName=VAL_BLK| varName=VALUE)
                     -> ^(PartialIdent $varName (ArraySpecifier $arSpec)*);
uint: (POS_INT | HEX_NUMBER);
physUnit: PHYS_UNIT^ STRING;
refMemorySegment: REF_MEMORY_SEGMENT^ ident;
stepSize: STEP_SIZE^ FLOAT;
symbolLink: SYMBOL_LINK^ STRING (uint | NEG_INT);
tag: STRING -> ^(Tag STRING);
type: ASCII -> ^(Type ASCII)
    | CURVE -> ^(Type CURVE)
    | MAP -> ^(Type MAP)
    | CUBOID -> ^(Type CUBOID)
    | CUBE_4 -> ^(Type CUBE_4)
    | CUBE_5 -> ^(Type CUBE_5)
    | VAL_BLK -> ^(Type VAL_BLK)
    | VALUE -> ^(Type VALUE)
;
version: uint -> ^(Version uint);

MULTILINE_COMMENT:   '/*' (options {greedy=false;} : .)* '*/' {$channel=HIDDEN;};
SINGLELINE_COMMENT: '//' ( ~('\r'|'\n')* ) NEWLINE {$channel=HIDDEN;};
WS: WS_CHARACTER+ {$channel=HIDDEN;};
POS_INT  : ('0'..'9')+;
NEG_INT :	'-' POS_INT;
FLOAT: ('-')? DIGIT+  '.' DIGIT* EXPONENT? ; // TODO The dot is optional, but this leads to conflicts with POS_INT
HEX_NUMBER
	:	 '0' ('x'|'X') HEX_DIGIT+;
VAR_NAME: (LETTER|'_')(LETTER|DIGIT|'_')*;
STRING: '"' (~'"'|'""')* '"';    // see ASAM_MCD-2MC_DataSpecification_V1.6.pdf, chapter 3.2: "Predefined Data Types"
//A2ML_BLOCK: BEGIN WS? A2ML (options {greedy=false;} : .)* END WS? A2ML;

// Supporting Windows and Unix linebreaks. (Windows: \r\n, Unix: \n).
fragment NEWLINE: '\r'? '\n';
fragment WS_CHARACTER: ' '|'\t'|'\r'|'\n';
fragment DIGIT: '0'..'9';
fragment UPPER_CASE_LETTER: 'a'..'z';
fragment LOWER_CASE_LETTER: 'A'..'Z';
fragment LETTER: UPPER_CASE_LETTER|LOWER_CASE_LETTER;
fragment EXPONENT: ('e'|'E') '-'? DIGIT+;
fragment HEX_DIGIT
	:	'0'..'9' | 'A'..'F' | 'a'..'f';